Given an array arr[] of size N, the task is to find the minimum value range [L, R] such that:
- The array can be divided into K sub-arrays.
- The elements within the range [L, R] are greater than the elements which are out of the range[l, r].
Examples:
Input: arr[] = {1, 2, 2, 2}, K = 2
Output: 2 2
Explanation: [2, 2] is the range with minimum distance which can split the array into two sub-arrays as
{1, 2, 2} -> inrange = 2, outrange =1
{2} -> inrange =1, outrange = 0.
In the 2 splits number of elements inrange > outrange.Input: arr[] = {1, 2, 3, 4}, K = 3
Output: 1 4
Explanation : [1, 4] is the range with minimum distance because the array can be splitted into 3 subarrays as
{1, 2} -> inrange = 2, outrange =1 ,
{3} -> inrange =1, outrange = 0,
{4} -> inrange = 1, outrange = 0.
In the 3 splits number of elements inrange > outrange.
Naive Approach: This can be done by checking the ranges of every size from 1 to the size of the array, then checking the number of elements in the range and the number of elements out of the range, later checking if their difference is greater than or equal to K.
Time Complexity: O(N2)
Auxiliary Space: O(N)
Efficient approach: This approach is based on a Binary search of the range [1, N] with Hashing technique and prefix sum to keep track of the number of elements in the array that are in the range till i and checking if there is a possibility for any range which can divide the array into K sub-arrays that follow the given condition. Follow the mentioned steps:
- Initialize the count vector to store the frequencies of the elements of the array.
- Initialize a vector prefix sum to store the number of elements till that index.
- Now traverse through the array from[1, N] and store the count of elements till i using the prefix sum technique.
- Initialize can= 0, and l, r to store the range and low = 0, high = N to perform a binary search on the size of the range.
- Perform binary search while low ≤ high.
- Initialize mid as (low + high)/2.
- Iterate using the for loop from [1, N-mid+1] using i to check which range of size mid.
- Now Count the number of elements in the range [i, i+mid-1] and out of the range.
- Check if the difference of the elements in range and out range is greater than or equal to K.
- Store the range in the l, r and make can =1 if it is greater than equal to K.
- If there is a possibility then make high as mid-1
- Else low= mid +1.
- Print the range.
Below is the implementation of the above approach.
C++
// C++ code for the above approach #include <bits/stdc++.h> using namespace std; // Function to minimize the range // To divide the array arr // Into k subarrays that has // Number of elements in the range // Greater than out of range void find_minrange(vector< int > arr, int n, int k) { // Initialize the count vector // To store the frequencies // Of the elements vector< int > count(n + 1); for ( auto x : arr) count[x]++; // Initialize a vector prefix sum to // Store the number of elements till // That index vector< int > prefixsum(n + 1); // Now traverse through from[1, n] // And store the count of elements till i for ( int i = 1; i <= n; i++) prefixsum[i] = prefixsum[i - 1] + count[i]; int low = 1, high = n; // Initialize l, r to store the range int l, r; while (low <= high) { // Initialize the mid int mid = (low + high) / 2; bool can = false ; // For each range size (mid) for ( int i = 1; i <= n - mid + 1; i++) { // Count the number of elements // In the range [i, i+mid-1] // And out of the range int inrange = prefixsum[i + mid - 1] - prefixsum[i - 1]; int outrange = n - inrange; // Check if the difference of inrange // And outrange is greater than // or equal to k if (inrange - outrange >= k) { // Store the range // Since it is a possible range can = true ; l = i; r = i + mid - 1; break ; } } // If we have a possible range // Minimize it if (can) { high = mid - 1; } else { low = mid + 1; } } // Print the range cout << l << " " << r; } // Driver Code int main() { // Initialize the array arr[] vector< int > arr = { 1, 2, 2, 2 }; int K = 2; int N = arr.size(); // Function call find_minrange(arr, N, K); return 0; } |
Java
// Java program to implement // the above approach import java.util.*; class GFG { // Function to minimize the range // To divide the array arr // Into k subarrays that has // Number of elements in the range // Greater than out of range static void find_minrange( int [] arr, int n, int k) { // Initialize the count vector // To store the frequencies // Of the elements int [] count = new int [n + 1 ]; for ( int i = 0 ; i < arr.length; i++) count[arr[i]]++; // Initialize a vector prefix sum to // Store the number of elements till // That index int [] prefixsum = new int [n + 1 ]; // Now traverse through from[1, n] // And store the count of elements till i for ( int i = 1 ; i <= n; i++) prefixsum[i] = prefixsum[i - 1 ] + count[i]; int low = 1 , high = n; // Initialize l, r to store the range int l = 0 , r = 0 ; while (low <= high) { // Initialize the mid int mid = (low + high) / 2 ; boolean can = false ; // For each range size (mid) for ( int i = 1 ; i <= n - mid + 1 ; i++) { // Count the number of elements // In the range [i, i+mid-1] // And out of the range int inrange = prefixsum[i + mid - 1 ] - prefixsum[i - 1 ]; int outrange = n - inrange; // Check if the difference of inrange // And outrange is greater than // or equal to k if (inrange - outrange >= k) { // Store the range // Since it is a possible range can = true ; l = i; r = i + mid - 1 ; break ; } } // If we have a possible range // Minimize it if (can == true ) { high = mid - 1 ; } else { low = mid + 1 ; } } // Print the range System.out.print(l + " " + r); } // Driver Code public static void main(String args[]) { // Initialize the array arr[] int [] arr = { 1 , 2 , 2 , 2 }; int K = 2 ; int N = arr.length; // Function call find_minrange(arr, N, K); } } // This code is contributed by code_hunt. |
Python3
# python3 code for the above approach # Function to minimize the range # To divide the array arr # Into k subarrays that has # Number of elements in the range # Greater than out of range def find_minrange(arr, n, k): # Initialize the count vector # To store the frequencies # Of the elements count = [ 0 for _ in range (n + 1 )] for x in arr: count[x] + = 1 # Initialize a vector prefix sum to # Store the number of elements till # That index prefixsum = [ 0 for _ in range (n + 1 )] # Now traverse through from[1, n] # And store the count of elements till i for i in range ( 1 , n + 1 ): prefixsum[i] = prefixsum[i - 1 ] + count[i] low, high = 1 , n # Initialize l, r to store the range l, r = 0 , 0 while (low < = high): # Initialize the mid mid = (low + high) / / 2 can = False # For each range size (mid) for i in range ( 1 , n - mid + 1 + 1 ): # Count the number of elements # In the range [i, i+mid-1] # // And out of the range inrange = prefixsum[i + mid - 1 ] - prefixsum[i - 1 ] outrange = n - inrange # Check if the difference of inrange # And outrange is greater than # or equal to k if (inrange - outrange > = k): # Store the range # Since it is a possible range can = True l = i r = i + mid - 1 break # If we have a possible range # Minimize it if (can): high = mid - 1 else : low = mid + 1 # Print the range print (f "{l} {r}" ) # Driver Code if __name__ = = "__main__" : # Initialize the array arr[] arr = [ 1 , 2 , 2 , 2 ] K = 2 N = len (arr) # Function call find_minrange(arr, N, K) # This code is contributed by rakeshsahni |
C#
// C# code for the above approach using System; class GFG { // Function to minimize the range // To divide the array arr // Into k subarrays that has // Number of elements in the range // Greater than out of range static void find_minrange( int [] arr, int n, int k) { // Initialize the count vector // To store the frequencies // Of the elements int [] count = new int [n + 1]; for ( int i = 0; i < arr.Length; i++) count[arr[i]]++; // Initialize a vector prefix sum to // Store the number of elements till // That index int [] prefixsum = new int [n + 1]; // Now traverse through from[1, n] // And store the count of elements till i for ( int i = 1; i <= n; i++) prefixsum[i] = prefixsum[i - 1] + count[i]; int low = 1, high = n; // Initialize l, r to store the range int l = 0, r = 0; while (low <= high) { // Initialize the mid int mid = (low + high) / 2; bool can = false ; // For each range size (mid) for ( int i = 1; i <= n - mid + 1; i++) { // Count the number of elements // In the range [i, i+mid-1] // And out of the range int inrange = prefixsum[i + mid - 1] - prefixsum[i - 1]; int outrange = n - inrange; // Check if the difference of inrange // And outrange is greater than // or equal to k if (inrange - outrange >= k) { // Store the range // Since it is a possible range can = true ; l = i; r = i + mid - 1; break ; } } // If we have a possible range // Minimize it if (can == true ) { high = mid - 1; } else { low = mid + 1; } } // Print the range Console.Write(l + " " + r); } // Driver Code public static void Main() { // Initialize the array arr[] int [] arr = { 1, 2, 2, 2 }; int K = 2; int N = arr.Length; // Function call find_minrange(arr, N, K); } } // This code is contributed by Samim Hossain Mondal. |
Javascript
<script> // JavaScript code for the above approach // Function to minimize the range // To divide the array arr // Into k subarrays that has // Number of elements in the range // Greater than out of range function find_minrange(arr,n,k) { // Initialize the count vector // To store the frequencies // Of the elements let count = new Array(n + 1).fill(0); for (let x of arr) count[x]++; // Initialize a vector prefix sum to // Store the number of elements till // That index let prefixsum = new Array(n + 1).fill(0); // Now traverse through from[1, n] // And store the count of elements till i for (let i = 1; i <= n; i++) prefixsum[i] = prefixsum[i - 1] + count[i]; let low = 1, high = n; // Initialize l, r to store the range let l, r; while (low <= high) { // Initialize the mid let mid = Math.floor((low + high) / 2); let can = false ; // For each range size (mid) for (let i = 1; i <= n - mid + 1; i++) { // Count the number of elements // In the range [i, i+mid-1] // And out of the range let inrange = prefixsum[i + mid - 1] - prefixsum[i - 1]; let outrange = n - inrange; // Check if the difference of inrange // And outrange is greater than // or equal to k if (inrange - outrange >= k) { // Store the range // Since it is a possible range can = true ; l = i; r = i + mid - 1; break ; } } // If we have a possible range // Minimize it if (can) { high = mid - 1; } else { low = mid + 1; } } // Print the range document.write(l + " " + r); } // Driver Code // Initialize the array arr[] let arr = [ 1, 2, 2, 2 ]; let K = 2; let N = arr.length; // Function call find_minrange(arr, N, K); // This code is contributed by shinjanpatra </script> |
2 2
Time Complexity: O(N* log(N))
Auxiliary Space: O(N)
Ready to dive in? Explore our Free Demo Content and join our DSA course, trusted by over 100,000 neveropen!